"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createGenerator = exports.options = exports.packageToPath = void 0;
const types_1 = require("@openapi-generator-plus/types");
const path_1 = __importDefault(require("path"));
const generator_common_1 = require("@openapi-generator-plus/generator-common");
const handlebars_templates_1 = require("@openapi-generator-plus/handlebars-templates");
const java_jaxrs_generator_common_1 = __importStar(require("@openapi-generator-plus/java-jaxrs-generator-common"));
var java_jaxrs_generator_common_2 = require("@openapi-generator-plus/java-jaxrs-generator-common");
Object.defineProperty(exports, "packageToPath", { enumerable: true, get: function () { return java_jaxrs_generator_common_2.packageToPath; } });
function options(config, context) {
    const options = (0, java_jaxrs_generator_common_1.options)(config, context);
    const packageName = config.package || 'com.example';
    const apiServicePackage = config.apiServicePackage || `${options.apiPackage}.service`;
    const result = Object.assign(Object.assign({}, options), { apiServicePackage, apiServiceImplPackage: config.apiServiceImplPackage || `${apiServicePackage}.impl`, apiProviderPackage: config.apiProviderPackage || `${packageName}.providers`, invokerPackage: config.invokerPackage !== undefined ? config.invokerPackage : `${packageName}.app`, authenticationRequiredAnnotation: config.authenticationRequiredAnnotation || config.authenticatedOperationAnnotation || null });
    return result;
}
exports.options = options;
const createGenerator = (config, context) => {
    const myContext = Object.assign(Object.assign({}, context), { loadAdditionalTemplates: async (hbs) => {
            await (0, handlebars_templates_1.loadTemplates)(path_1.default.resolve(__dirname, '../templates'), hbs);
            if (context.loadAdditionalTemplates) {
                await context.loadAdditionalTemplates(hbs);
            }
        }, additionalWatchPaths: () => {
            const result = [path_1.default.resolve(__dirname, '../templates')];
            if (context.additionalWatchPaths) {
                result.push(...context.additionalWatchPaths());
            }
            return result;
        } });
    const generatorOptions = options(config, myContext);
    myContext.additionalExportTemplates = async (outputPath, doc, hbs, rootContext) => {
        const relativeSourceOutputPath = generatorOptions.relativeSourceOutputPath;
        const apiPackagePath = (0, java_jaxrs_generator_common_1.packageToPath)(generatorOptions.apiPackage);
        for (const group of doc.groups) {
            const operations = group.operations;
            if (!operations.length) {
                continue;
            }
            await (0, handlebars_templates_1.emit)('api', path_1.default.join(outputPath, relativeSourceOutputPath, apiPackagePath, `${context.generator().toClassName(group.name)}Api.java`), Object.assign(Object.assign(Object.assign({}, rootContext), group), { operations }), true, hbs);
        }
        const apiImplPackagePath = (0, java_jaxrs_generator_common_1.packageToPath)(generatorOptions.apiImplPackage);
        for (const group of doc.groups) {
            const operations = group.operations;
            if (!operations.length) {
                continue;
            }
            await (0, handlebars_templates_1.emit)('apiImpl', path_1.default.join(outputPath, relativeSourceOutputPath, apiImplPackagePath, `${context.generator().toClassName(group.name)}ApiImpl.java`), Object.assign(Object.assign(Object.assign({}, rootContext), group), { operations }), true, hbs);
        }
        const apiServicePackagePath = (0, java_jaxrs_generator_common_1.packageToPath)(generatorOptions.apiServicePackage);
        for (const group of doc.groups) {
            const operations = group.operations;
            if (!operations.length) {
                continue;
            }
            await (0, handlebars_templates_1.emit)('apiService', path_1.default.join(outputPath, relativeSourceOutputPath, apiServicePackagePath, `${context.generator().toClassName(group.name)}ApiService.java`), Object.assign(Object.assign(Object.assign({}, rootContext), group), { operations }), true, hbs);
        }
        const apiServiceImplPackagePath = (0, java_jaxrs_generator_common_1.packageToPath)(generatorOptions.apiServiceImplPackage);
        for (const group of doc.groups) {
            const operations = group.operations;
            if (!operations.length) {
                continue;
            }
            await (0, handlebars_templates_1.emit)('apiServiceImpl', path_1.default.join(outputPath, relativeSourceOutputPath, apiServiceImplPackagePath, `${context.generator().toClassName(group.name)}ApiServiceImpl.java`), Object.assign(Object.assign({}, rootContext), group), false, hbs);
        }
        const invokerPackagePath = generatorOptions.invokerPackage ? (0, java_jaxrs_generator_common_1.packageToPath)(generatorOptions.invokerPackage) : undefined;
        if (invokerPackagePath) {
            const basePath = (0, generator_common_1.apiBasePath)(doc.servers);
            await (0, handlebars_templates_1.emit)('invoker', path_1.default.join(outputPath, relativeSourceOutputPath, invokerPackagePath, 'RestApplication.java'), Object.assign(Object.assign(Object.assign({}, rootContext), doc.info), { basePath }), false, hbs);
        }
        const providerPackagePath = generatorOptions.apiProviderPackage ? (0, java_jaxrs_generator_common_1.packageToPath)(generatorOptions.apiProviderPackage) : undefined;
        if (providerPackagePath) {
            await (0, handlebars_templates_1.emit)('ApiJaxbJsonProvider', path_1.default.join(outputPath, relativeSourceOutputPath, providerPackagePath, 'ApiJaxbJsonProvider.java'), Object.assign({}, rootContext), true, hbs);
        }
        if (context.additionalExportTemplates) {
            context.additionalExportTemplates(outputPath, doc, hbs, rootContext);
        }
    };
    myContext.additionalCleanPathPatterns = () => {
        const relativeSourceOutputPath = generatorOptions.relativeSourceOutputPath;
        const apiServicePackagePath = (0, java_jaxrs_generator_common_1.packageToPath)(generatorOptions.apiServicePackage);
        const result = [
            path_1.default.join(relativeSourceOutputPath, apiServicePackagePath, '*ApiService.java'),
        ];
        if (context.additionalCleanPathPatterns) {
            result.push(...context.additionalCleanPathPatterns());
        }
        return result;
    };
    const base = (0, java_jaxrs_generator_common_1.default)(config, myContext);
    return Object.assign(Object.assign({}, base), { templateRootContext: () => {
            return Object.assign(Object.assign(Object.assign({}, base.templateRootContext()), generatorOptions), { generatorClass: '@openapi-generator-plus/java-jaxrs-server-generator' });
        }, generatorType: () => types_1.CodegenGeneratorType.SERVER });
};
exports.createGenerator = createGenerator;
exports.default = exports.createGenerator;
